var $CLJS = require("./cljs_env");
require("./cljs.core.js");
require("./cljs.core.async.impl.protocols.js");
require("./cljs.core.async.impl.dispatch.js");
require("./cljs.core.async.impl.buffers.js");
var cljs=$CLJS.cljs;
var goog=$CLJS.goog;

goog.dependencies_.written["cljs.core.async.impl.channels.js"] = true;

goog.provide('cljs.core.async.impl.channels');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.buffers');
cljs.core.async.impl.channels.box = (function cljs$core$async$impl$channels$box(val){
if(typeof cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IDeref}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527 = (function (val,meta38528){
this.val = val;
this.meta38528 = meta38528;
this.cljs$lang$protocol_mask$partition0$ = 425984;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_38529,meta38528__$1){
var self__ = this;
var _38529__$1 = this;
return (new cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527(self__.val,meta38528__$1));
});

cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_38529){
var self__ = this;
var _38529__$1 = this;
return self__.meta38528;
});

cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.prototype.cljs$core$IDeref$_deref$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.val;
});

cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"val","val",1769233139,null),new cljs.core.Symbol(null,"meta38528","meta38528",168656268,null)], null);
});

cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.cljs$lang$type = true;

cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.cljs$lang$ctorStr = "cljs.core.async.impl.channels/t_cljs$core$async$impl$channels38527";

cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527.cljs$lang$ctorPrWriter = (function (this__33687__auto__,writer__33688__auto__,opt__33689__auto__){
return cljs.core._write(writer__33688__auto__,"cljs.core.async.impl.channels/t_cljs$core$async$impl$channels38527");
});

cljs.core.async.impl.channels.__GT_t_cljs$core$async$impl$channels38527 = (function cljs$core$async$impl$channels$box_$___GT_t_cljs$core$async$impl$channels38527(val__$1,meta38528){
return (new cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527(val__$1,meta38528));
});

}

return (new cljs.core.async.impl.channels.t_cljs$core$async$impl$channels38527(val,cljs.core.PersistentArrayMap.EMPTY));
});

/**
* @constructor
*/
cljs.core.async.impl.channels.PutBox = (function (handler,val){
this.handler = handler;
this.val = val;
});

cljs.core.async.impl.channels.PutBox.getBasis = (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"handler","handler",1444934915,null),new cljs.core.Symbol(null,"val","val",1769233139,null)], null);
});

cljs.core.async.impl.channels.PutBox.cljs$lang$type = true;

cljs.core.async.impl.channels.PutBox.cljs$lang$ctorStr = "cljs.core.async.impl.channels/PutBox";

cljs.core.async.impl.channels.PutBox.cljs$lang$ctorPrWriter = (function (this__33687__auto__,writer__33688__auto__,opt__33689__auto__){
return cljs.core._write(writer__33688__auto__,"cljs.core.async.impl.channels/PutBox");
});

cljs.core.async.impl.channels.__GT_PutBox = (function cljs$core$async$impl$channels$__GT_PutBox(handler,val){
return (new cljs.core.async.impl.channels.PutBox(handler,val));
});

cljs.core.async.impl.channels.put_active_QMARK_ = (function cljs$core$async$impl$channels$put_active_QMARK_(box){
return cljs.core.async.impl.protocols.active_QMARK_(box.handler);
});
cljs.core.async.impl.channels.MAX_DIRTY = (64);

/**
 * @interface
 */
cljs.core.async.impl.channels.MMC = function(){};

cljs.core.async.impl.channels.abort = (function cljs$core$async$impl$channels$abort(this$){
if((!((this$ == null))) && (!((this$.cljs$core$async$impl$channels$MMC$abort$arity$1 == null)))){
return this$.cljs$core$async$impl$channels$MMC$abort$arity$1(this$);
} else {
var x__33749__auto__ = (((this$ == null))?null:this$);
var m__33750__auto__ = (cljs.core.async.impl.channels.abort[goog.typeOf(x__33749__auto__)]);
if(!((m__33750__auto__ == null))){
return (m__33750__auto__.cljs$core$IFn$_invoke$arity$1 ? m__33750__auto__.cljs$core$IFn$_invoke$arity$1(this$) : m__33750__auto__.call(null,this$));
} else {
var m__33750__auto____$1 = (cljs.core.async.impl.channels.abort["_"]);
if(!((m__33750__auto____$1 == null))){
return (m__33750__auto____$1.cljs$core$IFn$_invoke$arity$1 ? m__33750__auto____$1.cljs$core$IFn$_invoke$arity$1(this$) : m__33750__auto____$1.call(null,this$));
} else {
throw cljs.core.missing_protocol("MMC.abort",this$);
}
}
}
});


/**
* @constructor
 * @implements {cljs.core.async.impl.channels.MMC}
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
*/
cljs.core.async.impl.channels.ManyToManyChannel = (function (takes,dirty_takes,puts,dirty_puts,buf,closed,add_BANG_){
this.takes = takes;
this.dirty_takes = dirty_takes;
this.puts = puts;
this.dirty_puts = dirty_puts;
this.buf = buf;
this.closed = closed;
this.add_BANG_ = add_BANG_;
});
cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$channels$MMC$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$channels$MMC$abort$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
while(true){
var putter_38581 = self__.puts.pop();
if((putter_38581 == null)){
} else {
var put_handler_38582 = putter_38581.handler;
var val_38583 = putter_38581.val;
if(put_handler_38582.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null)){
var put_cb_38584 = put_handler_38582.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
cljs.core.async.impl.dispatch.run(((function (put_cb_38584,put_handler_38582,val_38583,putter_38581,this$__$1){
return (function (){
return (put_cb_38584.cljs$core$IFn$_invoke$arity$1 ? put_cb_38584.cljs$core$IFn$_invoke$arity$1(true) : put_cb_38584.call(null,true));
});})(put_cb_38584,put_handler_38582,val_38583,putter_38581,this$__$1))
);
} else {
continue;
}
}
break;
}

self__.puts.cleanup(cljs.core.constantly(false));

return cljs.core.async.impl.protocols.close_BANG_(this$__$1);
});

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (this$,val,handler){
var self__ = this;
var this$__$1 = this;
if(!((val == null))){
} else {
throw (new Error(["Assert failed: ","Can't put nil in on a channel","\n","(not (nil? val))"].join('')));
}

var closed__$1 = self__.closed;
if((closed__$1) || (!(handler.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null)))){
return cljs.core.async.impl.channels.box(!(closed__$1));
} else {
if(cljs.core.truth_((function (){var and__33004__auto__ = self__.buf;
if(cljs.core.truth_(and__33004__auto__)){
return cljs.core.not(self__.buf.cljs$core$async$impl$protocols$Buffer$full_QMARK_$arity$1(null));
} else {
return and__33004__auto__;
}
})())){
handler.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);

var done_QMARK_ = cljs.core.reduced_QMARK_((self__.add_BANG_.cljs$core$IFn$_invoke$arity$2 ? self__.add_BANG_.cljs$core$IFn$_invoke$arity$2(self__.buf,val) : self__.add_BANG_.call(null,self__.buf,val)));
var take_cbs = (function (){var takers = cljs.core.PersistentVector.EMPTY;
while(true){
if(((self__.takes.length > (0))) && ((cljs.core.count(self__.buf) > (0)))){
var taker = self__.takes.pop();
if(taker.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null)){
var ret = taker.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
var val__$1 = self__.buf.cljs$core$async$impl$protocols$Buffer$remove_BANG_$arity$1(null);
var G__38585 = cljs.core.conj.cljs$core$IFn$_invoke$arity$2(takers,((function (takers,ret,val__$1,taker,done_QMARK_,closed__$1,this$__$1){
return (function (){
return (ret.cljs$core$IFn$_invoke$arity$1 ? ret.cljs$core$IFn$_invoke$arity$1(val__$1) : ret.call(null,val__$1));
});})(takers,ret,val__$1,taker,done_QMARK_,closed__$1,this$__$1))
);
takers = G__38585;
continue;
} else {
var G__38587 = takers;
takers = G__38587;
continue;
}
} else {
return takers;
}
break;
}
})();
if(done_QMARK_){
cljs.core.async.impl.channels.abort(this$__$1);
} else {
}

if(cljs.core.seq(take_cbs)){
var seq__38569_38588 = cljs.core.seq(take_cbs);
var chunk__38570_38589 = null;
var count__38571_38590 = (0);
var i__38572_38591 = (0);
while(true){
if((i__38572_38591 < count__38571_38590)){
var f_38592 = chunk__38570_38589.cljs$core$IIndexed$_nth$arity$2(null,i__38572_38591);
cljs.core.async.impl.dispatch.run(f_38592);

var G__38593 = seq__38569_38588;
var G__38594 = chunk__38570_38589;
var G__38595 = count__38571_38590;
var G__38596 = (i__38572_38591 + (1));
seq__38569_38588 = G__38593;
chunk__38570_38589 = G__38594;
count__38571_38590 = G__38595;
i__38572_38591 = G__38596;
continue;
} else {
var temp__5457__auto___38597 = cljs.core.seq(seq__38569_38588);
if(temp__5457__auto___38597){
var seq__38569_38598__$1 = temp__5457__auto___38597;
if(cljs.core.chunked_seq_QMARK_(seq__38569_38598__$1)){
var c__33947__auto___38599 = cljs.core.chunk_first(seq__38569_38598__$1);
var G__38600 = cljs.core.chunk_rest(seq__38569_38598__$1);
var G__38601 = c__33947__auto___38599;
var G__38602 = cljs.core.count(c__33947__auto___38599);
var G__38603 = (0);
seq__38569_38588 = G__38600;
chunk__38570_38589 = G__38601;
count__38571_38590 = G__38602;
i__38572_38591 = G__38603;
continue;
} else {
var f_38604 = cljs.core.first(seq__38569_38598__$1);
cljs.core.async.impl.dispatch.run(f_38604);

var G__38605 = cljs.core.next(seq__38569_38598__$1);
var G__38606 = null;
var G__38607 = (0);
var G__38608 = (0);
seq__38569_38588 = G__38605;
chunk__38570_38589 = G__38606;
count__38571_38590 = G__38607;
i__38572_38591 = G__38608;
continue;
}
} else {
}
}
break;
}
} else {
}

return cljs.core.async.impl.channels.box(true);
} else {
var taker = (function (){while(true){
var taker = self__.takes.pop();
if(cljs.core.truth_(taker)){
if(cljs.core.truth_(taker.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null))){
return taker;
} else {
continue;
}
} else {
return null;
}
break;
}
})();
if(cljs.core.truth_(taker)){
var take_cb = cljs.core.async.impl.protocols.commit(taker);
handler.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);

cljs.core.async.impl.dispatch.run(((function (take_cb,taker,closed__$1,this$__$1){
return (function (){
return (take_cb.cljs$core$IFn$_invoke$arity$1 ? take_cb.cljs$core$IFn$_invoke$arity$1(val) : take_cb.call(null,val));
});})(take_cb,taker,closed__$1,this$__$1))
);

return cljs.core.async.impl.channels.box(true);
} else {
if((self__.dirty_puts > (64))){
self__.dirty_puts = (0);

self__.puts.cleanup(cljs.core.async.impl.channels.put_active_QMARK_);
} else {
self__.dirty_puts = (self__.dirty_puts + (1));
}

if(cljs.core.truth_(handler.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1(null))){
if((self__.puts.length < (1024))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(["No more than ",cljs.core.str.cljs$core$IFn$_invoke$arity$1((1024))," pending puts are allowed on a single channel."," Consider using a windowed buffer."].join('')),"\n","(< (.-length puts) impl/MAX-QUEUE-SIZE)"].join('')));
}

self__.puts.unbounded_unshift((new cljs.core.async.impl.channels.PutBox(handler,val)));
} else {
}

return null;
}
}
}
});

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (this$,handler){
var self__ = this;
var this$__$1 = this;
if(!(handler.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null))){
return null;
} else {
if((!((self__.buf == null))) && ((cljs.core.count(self__.buf) > (0)))){
var temp__5455__auto__ = handler.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
if(cljs.core.truth_(temp__5455__auto__)){
var take_cb = temp__5455__auto__;
var val = self__.buf.cljs$core$async$impl$protocols$Buffer$remove_BANG_$arity$1(null);
var vec__38573 = (((self__.puts.length > (0)))?(function (){var cbs = cljs.core.PersistentVector.EMPTY;
while(true){
var putter = self__.puts.pop();
var put_handler = putter.handler;
var val__$1 = putter.val;
var cb = (function (){var and__33004__auto__ = put_handler.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null);
if(and__33004__auto__){
return put_handler.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
} else {
return and__33004__auto__;
}
})();
var cbs__$1 = (cljs.core.truth_(cb)?cljs.core.conj.cljs$core$IFn$_invoke$arity$2(cbs,cb):cbs);
var done_QMARK_ = (cljs.core.truth_(cb)?cljs.core.reduced_QMARK_((self__.add_BANG_.cljs$core$IFn$_invoke$arity$2 ? self__.add_BANG_.cljs$core$IFn$_invoke$arity$2(self__.buf,val__$1) : self__.add_BANG_.call(null,self__.buf,val__$1))):null);
if((cljs.core.not(done_QMARK_)) && (cljs.core.not(self__.buf.cljs$core$async$impl$protocols$Buffer$full_QMARK_$arity$1(null))) && ((self__.puts.length > (0)))){
var G__38616 = cbs__$1;
cbs = G__38616;
continue;
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [done_QMARK_,cbs__$1], null);
}
break;
}
})():null);
var done_QMARK_ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__38573,(0),null);
var cbs = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__38573,(1),null);
if(cljs.core.truth_(done_QMARK_)){
cljs.core.async.impl.channels.abort(this$__$1);
} else {
}

var seq__38577_38618 = cljs.core.seq(cbs);
var chunk__38578_38619 = null;
var count__38579_38620 = (0);
var i__38580_38621 = (0);
while(true){
if((i__38580_38621 < count__38579_38620)){
var cb_38622 = chunk__38578_38619.cljs$core$IIndexed$_nth$arity$2(null,i__38580_38621);
cljs.core.async.impl.dispatch.run(((function (seq__38577_38618,chunk__38578_38619,count__38579_38620,i__38580_38621,cb_38622,val,vec__38573,done_QMARK_,cbs,take_cb,temp__5455__auto__,this$__$1){
return (function (){
return (cb_38622.cljs$core$IFn$_invoke$arity$1 ? cb_38622.cljs$core$IFn$_invoke$arity$1(true) : cb_38622.call(null,true));
});})(seq__38577_38618,chunk__38578_38619,count__38579_38620,i__38580_38621,cb_38622,val,vec__38573,done_QMARK_,cbs,take_cb,temp__5455__auto__,this$__$1))
);

var G__38627 = seq__38577_38618;
var G__38628 = chunk__38578_38619;
var G__38629 = count__38579_38620;
var G__38630 = (i__38580_38621 + (1));
seq__38577_38618 = G__38627;
chunk__38578_38619 = G__38628;
count__38579_38620 = G__38629;
i__38580_38621 = G__38630;
continue;
} else {
var temp__5457__auto___38632 = cljs.core.seq(seq__38577_38618);
if(temp__5457__auto___38632){
var seq__38577_38633__$1 = temp__5457__auto___38632;
if(cljs.core.chunked_seq_QMARK_(seq__38577_38633__$1)){
var c__33947__auto___38634 = cljs.core.chunk_first(seq__38577_38633__$1);
var G__38635 = cljs.core.chunk_rest(seq__38577_38633__$1);
var G__38636 = c__33947__auto___38634;
var G__38637 = cljs.core.count(c__33947__auto___38634);
var G__38638 = (0);
seq__38577_38618 = G__38635;
chunk__38578_38619 = G__38636;
count__38579_38620 = G__38637;
i__38580_38621 = G__38638;
continue;
} else {
var cb_38639 = cljs.core.first(seq__38577_38633__$1);
cljs.core.async.impl.dispatch.run(((function (seq__38577_38618,chunk__38578_38619,count__38579_38620,i__38580_38621,cb_38639,seq__38577_38633__$1,temp__5457__auto___38632,val,vec__38573,done_QMARK_,cbs,take_cb,temp__5455__auto__,this$__$1){
return (function (){
return (cb_38639.cljs$core$IFn$_invoke$arity$1 ? cb_38639.cljs$core$IFn$_invoke$arity$1(true) : cb_38639.call(null,true));
});})(seq__38577_38618,chunk__38578_38619,count__38579_38620,i__38580_38621,cb_38639,seq__38577_38633__$1,temp__5457__auto___38632,val,vec__38573,done_QMARK_,cbs,take_cb,temp__5455__auto__,this$__$1))
);

var G__38640 = cljs.core.next(seq__38577_38633__$1);
var G__38641 = null;
var G__38642 = (0);
var G__38643 = (0);
seq__38577_38618 = G__38640;
chunk__38578_38619 = G__38641;
count__38579_38620 = G__38642;
i__38580_38621 = G__38643;
continue;
}
} else {
}
}
break;
}

return cljs.core.async.impl.channels.box(val);
} else {
return null;
}
} else {
var putter = (function (){while(true){
var putter = self__.puts.pop();
if(cljs.core.truth_(putter)){
if(cljs.core.async.impl.protocols.active_QMARK_(putter.handler)){
return putter;
} else {
continue;
}
} else {
return null;
}
break;
}
})();
if(cljs.core.truth_(putter)){
var put_cb = cljs.core.async.impl.protocols.commit(putter.handler);
handler.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);

cljs.core.async.impl.dispatch.run(((function (put_cb,putter,this$__$1){
return (function (){
return (put_cb.cljs$core$IFn$_invoke$arity$1 ? put_cb.cljs$core$IFn$_invoke$arity$1(true) : put_cb.call(null,true));
});})(put_cb,putter,this$__$1))
);

return cljs.core.async.impl.channels.box(putter.val);
} else {
if(cljs.core.truth_(self__.closed)){
if(cljs.core.truth_(self__.buf)){
(self__.add_BANG_.cljs$core$IFn$_invoke$arity$1 ? self__.add_BANG_.cljs$core$IFn$_invoke$arity$1(self__.buf) : self__.add_BANG_.call(null,self__.buf));
} else {
}

if(cljs.core.truth_((function (){var and__33004__auto__ = handler.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null);
if(cljs.core.truth_(and__33004__auto__)){
return handler.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
} else {
return and__33004__auto__;
}
})())){
var has_val = (function (){var and__33004__auto__ = self__.buf;
if(cljs.core.truth_(and__33004__auto__)){
return (cljs.core.count(self__.buf) > (0));
} else {
return and__33004__auto__;
}
})();
var val = (cljs.core.truth_(has_val)?self__.buf.cljs$core$async$impl$protocols$Buffer$remove_BANG_$arity$1(null):null);
return cljs.core.async.impl.channels.box(val);
} else {
return null;
}
} else {
if((self__.dirty_takes > (64))){
self__.dirty_takes = (0);

self__.takes.cleanup(cljs.core.async.impl.protocols.active_QMARK_);
} else {
self__.dirty_takes = (self__.dirty_takes + (1));
}

if(cljs.core.truth_(handler.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1(null))){
if((self__.takes.length < (1024))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(["No more than ",cljs.core.str.cljs$core$IFn$_invoke$arity$1((1024))," pending takes are allowed on a single channel."].join('')),"\n","(< (.-length takes) impl/MAX-QUEUE-SIZE)"].join('')));
}

self__.takes.unbounded_unshift(handler);
} else {
}

return null;
}
}
}
}
});

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.closed;
});

cljs.core.async.impl.channels.ManyToManyChannel.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if(self__.closed){
return null;
} else {
self__.closed = true;

if(cljs.core.truth_((function (){var and__33004__auto__ = self__.buf;
if(cljs.core.truth_(and__33004__auto__)){
return (self__.puts.length === (0));
} else {
return and__33004__auto__;
}
})())){
(self__.add_BANG_.cljs$core$IFn$_invoke$arity$1 ? self__.add_BANG_.cljs$core$IFn$_invoke$arity$1(self__.buf) : self__.add_BANG_.call(null,self__.buf));
} else {
}

while(true){
var taker_38650 = self__.takes.pop();
if((taker_38650 == null)){
} else {
if(taker_38650.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1(null)){
var take_cb_38651 = taker_38650.cljs$core$async$impl$protocols$Handler$commit$arity$1(null);
var val_38652 = (cljs.core.truth_((function (){var and__33004__auto__ = self__.buf;
if(cljs.core.truth_(and__33004__auto__)){
return (cljs.core.count(self__.buf) > (0));
} else {
return and__33004__auto__;
}
})())?self__.buf.cljs$core$async$impl$protocols$Buffer$remove_BANG_$arity$1(null):null);
cljs.core.async.impl.dispatch.run(((function (take_cb_38651,val_38652,taker_38650,this$__$1){
return (function (){
return (take_cb_38651.cljs$core$IFn$_invoke$arity$1 ? take_cb_38651.cljs$core$IFn$_invoke$arity$1(val_38652) : take_cb_38651.call(null,val_38652));
});})(take_cb_38651,val_38652,taker_38650,this$__$1))
);
} else {
}

continue;
}
break;
}

if(cljs.core.truth_(self__.buf)){
self__.buf.cljs$core$async$impl$protocols$Buffer$close_buf_BANG_$arity$1(null);
} else {
}

return null;
}
});

cljs.core.async.impl.channels.ManyToManyChannel.getBasis = (function (){
return new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"takes","takes",298247964,null),cljs.core.with_meta(new cljs.core.Symbol(null,"dirty-takes","dirty-takes",575642138,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"mutable","mutable",875778266),true], null)),new cljs.core.Symbol(null,"puts","puts",-1883877054,null),cljs.core.with_meta(new cljs.core.Symbol(null,"dirty-puts","dirty-puts",57041148,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"mutable","mutable",875778266),true], null)),cljs.core.with_meta(new cljs.core.Symbol(null,"buf","buf",1426618187,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol(null,"not-native","not-native",-236392494,null)], null)),cljs.core.with_meta(new cljs.core.Symbol(null,"closed","closed",720856168,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"mutable","mutable",875778266),true], null)),new cljs.core.Symbol(null,"add!","add!",2046056845,null)], null);
});

cljs.core.async.impl.channels.ManyToManyChannel.cljs$lang$type = true;

cljs.core.async.impl.channels.ManyToManyChannel.cljs$lang$ctorStr = "cljs.core.async.impl.channels/ManyToManyChannel";

cljs.core.async.impl.channels.ManyToManyChannel.cljs$lang$ctorPrWriter = (function (this__33687__auto__,writer__33688__auto__,opt__33689__auto__){
return cljs.core._write(writer__33688__auto__,"cljs.core.async.impl.channels/ManyToManyChannel");
});

cljs.core.async.impl.channels.__GT_ManyToManyChannel = (function cljs$core$async$impl$channels$__GT_ManyToManyChannel(takes,dirty_takes,puts,dirty_puts,buf,closed,add_BANG_){
return (new cljs.core.async.impl.channels.ManyToManyChannel(takes,dirty_takes,puts,dirty_puts,buf,closed,add_BANG_));
});

cljs.core.async.impl.channels.ex_handler = (function cljs$core$async$impl$channels$ex_handler(ex){
console.log(ex);

return null;
});
cljs.core.async.impl.channels.handle = (function cljs$core$async$impl$channels$handle(buf,exh,t){
var else$ = (function (){var fexpr__38654 = (function (){var or__33016__auto__ = exh;
if(cljs.core.truth_(or__33016__auto__)){
return or__33016__auto__;
} else {
return cljs.core.async.impl.channels.ex_handler;
}
})();
return (fexpr__38654.cljs$core$IFn$_invoke$arity$1 ? fexpr__38654.cljs$core$IFn$_invoke$arity$1(t) : fexpr__38654.call(null,t));
})();
if((else$ == null)){
return buf;
} else {
return cljs.core.async.impl.protocols.add_BANG_.cljs$core$IFn$_invoke$arity$2(buf,else$);
}
});
cljs.core.async.impl.channels.chan = (function cljs$core$async$impl$channels$chan(var_args){
var G__38660 = arguments.length;
switch (G__38660) {
case 1:
return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf){
return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$2(buf,null);
});

cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf,xform){
return cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3(buf,xform,null);
});

cljs.core.async.impl.channels.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf,xform,exh){
return (new cljs.core.async.impl.channels.ManyToManyChannel(cljs.core.async.impl.buffers.ring_buffer((32)),(0),cljs.core.async.impl.buffers.ring_buffer((32)),(0),buf,false,(function (){var add_BANG_ = (cljs.core.truth_(xform)?(xform.cljs$core$IFn$_invoke$arity$1 ? xform.cljs$core$IFn$_invoke$arity$1(cljs.core.async.impl.protocols.add_BANG_) : xform.call(null,cljs.core.async.impl.protocols.add_BANG_)):cljs.core.async.impl.protocols.add_BANG_);
return ((function (add_BANG_){
return (function() {
var G__38664 = null;
var G__38664__1 = (function (buf__$1){
try{return (add_BANG_.cljs$core$IFn$_invoke$arity$1 ? add_BANG_.cljs$core$IFn$_invoke$arity$1(buf__$1) : add_BANG_.call(null,buf__$1));
}catch (e38661){var t = e38661;
return cljs.core.async.impl.channels.handle(buf__$1,exh,t);
}});
var G__38664__2 = (function (buf__$1,val){
try{return (add_BANG_.cljs$core$IFn$_invoke$arity$2 ? add_BANG_.cljs$core$IFn$_invoke$arity$2(buf__$1,val) : add_BANG_.call(null,buf__$1,val));
}catch (e38662){var t = e38662;
return cljs.core.async.impl.channels.handle(buf__$1,exh,t);
}});
G__38664 = function(buf__$1,val){
switch(arguments.length){
case 1:
return G__38664__1.call(this,buf__$1);
case 2:
return G__38664__2.call(this,buf__$1,val);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
G__38664.cljs$core$IFn$_invoke$arity$1 = G__38664__1;
G__38664.cljs$core$IFn$_invoke$arity$2 = G__38664__2;
return G__38664;
})()
;})(add_BANG_))
})()));
});

cljs.core.async.impl.channels.chan.cljs$lang$maxFixedArity = 3;


module.exports = cljs.core.async.impl.channels;

//# sourceMappingURL=cljs.core.async.impl.channels.js.map
